<!-- 质检单 -->
<template>
    <div class="table-box">
        <div style="padding-bottom: 16px">
            <PermissionButton
                :buttons="dataStore.buttons"
                @handleButtonClickCallback="handleButtonClickCallback"
            ></PermissionButton>
        </div>

        <ProTable
            ref="proTableRef"
            :columns="dataStore.columns"
            :request-api="getSubscribeListApi"
            :init-param="dataStore.initParam"
            @selectionChange="selectionChange"
        >
            <template v-slot:search>
                <SearchForm
                    @search="handleSearch"
                    @reset="handleReset"
                    :searchParams="dataStore.initParam"
                    :formData="dataStore.formData"
                />
            </template>

            <template #subscriber_name="scope">
                <a @click="handleOpen(scope.row)" class="break-word to-details">
                    {{ scope.row.subscriber_name }}
                </a>
            </template>
        </ProTable>
    </div>
</template>

<script setup lang="ts" name="foundationSubscribeList">
import SearchForm from "@/components/SearchForm/index.vue";
import ProTable from "@/components/ProTable/index.vue";
import PermissionButton from "@/components/PermissionButton/index.vue";
import { getSubscribeListApi } from "@/api/modules/subscribe";
import { nextTick } from "vue";
import { RULE_FORM, FORM_DATA, COLUMNS, BUTTON } from "./constant/list/index";
//表格TS
import { ProTableInstance } from "@/components/ProTable/interface";
import { btnClick } from "./init";
import { useRouter } from "vue-router";
import { useUserStore } from "@/stores/modules/user";

//深拷贝方法
import { cloneDeep } from "lodash-es";
// 获取 ProTable 元素，调用其获取刷新数据方法（还能获取到当前查询参数，方便导出携带参数）
const proTableRef = ref<ProTableInstance>();
const router = useRouter();
const userStore = useUserStore();

// 数据源
const dataStore = reactive<any>({
    columns: COLUMNS, //列表配置项
    initParam: cloneDeep(RULE_FORM), // 初始化搜索条件|重置搜索条件
    ruleForm: cloneDeep(RULE_FORM), // 搜索条件
    formData: FORM_DATA, //搜索配置项
    buttons: cloneDeep(BUTTON),
    options: [], //规格型号
    selectionList: [], //选中表格的行
    loading: false
});
//初始化组织数据
const init = () => {
    if (userStore.orgIdArr.length) {
        dataStore.formData[0].options = userStore?.orgIdArr;
    }
};
init();
// 表格选择事件
const selectionChange = (selection: any) => {
    dataStore.selectionList = selection;
};
//顶部按钮事件
const handleButtonClickCallback = (item: any) => {
    const { type } = item;
    btnClick[type]({
        item,
        selectionList: dataStore.selectionList,
        proTable: proTableRef,
        router
    });
};
//搜索
const handleSearch = async (params: any) => {
    dataStore.initParam = cloneDeep(params);
    //这里需要等到表格刷新以后才去请求
    nextTick(() => {
        proTableRef.value!.getTableList();
    });
};
//重置
const handleReset = () => {
    dataStore.initParam = cloneDeep(RULE_FORM);
    //这里需要等到表格刷新以后才去请求
    nextTick(() => {
        proTableRef.value!.getTableList();
    });
};

//跳转详情
const handleOpen = (row: any) => {
    router.push({
        path: "/foundation/subscribe/list/add",
        query: { id: row.id, title: "编辑订阅" }
    });
};
</script>

<style scope lang="scss">
.down-dialog-box {
    .el-dialog__body {
        padding: 0 16px 40px;
    }
}
</style>
